com.brightcove.player.event

## Class AbstractEvent<PropertyValueType>

- java.lang.Object
- - com.brightcove.player.event.AbstractEvent<PropertyValueType>

- Direct Known Subclasses:
    Event, MediaEvent

      public abstract class AbstractEvent<PropertyValueType>
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `ACTIVITY` The key for Activity on the FRAGMENT_ATTACHED lifecycle event.
    `static java.lang.String` | `AD_ID` The key for ad id used in advertising events.
    `static java.lang.String` | `AD_TITLE` The key for ad title used in advertising events.
    `static java.lang.String` | `ALIGNMENT` The alignment property of a CAPTION event.
    `static java.lang.String` | `ANDROID_VIEW` The event property that specifies `View`.
    `static java.lang.String` | `AUDIO_TRACKS_STATE` The key for events accessing audio tracks state.
    `static java.lang.String` | `AUDIO_VARIANT` The key for the list of audio variants in AUDIO_TRACKS events.
    `static java.lang.String` | `BOOLEAN` The key for a general boolean property.
    `static java.lang.String` | `BRIGHTCOVE_CONTROL_BAR` The event property that specifies the `BrightcoveControlBar`.
    `static java.lang.String` | `BRIGHTCOVE_MEDIA_CONTROLLER` The event property that specifies the `BrightcoveMediaController`.
    `static java.lang.String` | `BUILD_VERSION`
    `static java.lang.String` | `CAPTION_FORMAT` The key containing the `BrightcoveCaptionFormat` selected.
    `static java.lang.String` | `CAPTION_URI` The key containing the uri for the `BrightcoveCaptionFormat` selected.
    `static java.lang.String` | `CAPTIONS_STATE` The key for events accessing caption state.
    `static java.lang.String` | `CATALOG_URL` The key for catalog urls used in the Analytics catalog request and response events.
    `static java.lang.String` | `CEA608_DOCUMENT` The key for events carrying CEA-608 data.
    `static java.lang.String` | `CEA708_DOCUMENT` The key for events carrying CEA-708 data.
    `static java.lang.String` | `CONFIGURATION` Key for Events that carry a configuration in their payload.
    `static java.lang.String` | `CUE_POINT` Key for Events that carry a single Cue Point.
    `static java.lang.String` | `CUE_POINTS` Key for Events that carry a list of Cue Points.
    `static java.lang.String` | `CURRENT_VIDEO` Video for Events that carry a current Video.
    `static java.lang.String` | `DEBUG` Whether components should emit additional debug information.
    `static java.lang.String` | `EMITTER` The simple name of the source component for an event when running in debug mode
    `static java.lang.String` | `END_TIME` Deprecated.
    `static java.lang.String` | `END_TIME_LONG` The end of the time range of a list of cue points
    `static java.lang.String` | `ERROR` Key for an actual exception associated with a playback error
    `static java.lang.String` | `ERROR_CODE` Key for the error code sent for a non-playable source
    `static java.lang.String` | `ERROR_EXTRA` Key for the extra code sent during an error for non-playable source
    `static java.lang.String` | `ERROR_MESSAGE` Used to transmit an error message when an error occurs
    `static java.lang.String` | `ERROR_SUBCODE` Key for the error subcode sent for a non-playable source
    `static java.lang.String` | `ERRORS` Key for list of error messages in a response.
    `static java.lang.String` | `EVENT_SOURCE` Property that specifies the source class where the event originated.
    `static java.lang.String` | `FORWARD_BUFFER_SECONDS` The key for forward buffer seconds used in the Analytics class.
    `static java.lang.String` | `FRAGMENT` The key for the Fragment object on FRAGMENT_ACTIVITY_CREATED event.
    `static java.lang.String` | `FROM_SEEK_POSITION` Deprecated.
    `static java.lang.String` | `FROM_SEEK_POSITION_LONG` Position from which a seek began.
    `static java.lang.String` | `GSC_MAX_CONCURRENCY_REACHED_MESSAGE` Key for the max concurrency reached message
    `static java.lang.String` | `ID` The property name of the unique identifier.
    `static java.lang.String` | `INDEX` Video for Events that carry a video index.
    `static java.lang.String` | `INSTANCE_STATE` The key for saving and restoring instance state on a lifecycle event.
    `protected boolean` | `isPrevented`
    `protected boolean` | `isStopped`
    `static java.lang.String` | `LANGUAGES` The key for the list of languages in CAPTIONS_LANGUAGES events.
    `static java.lang.String` | `LEFT_VOLUME` The setting of the left channel volume for a player (as float: 0.0f-1.0f inclusive).
    `static java.lang.String` | `LINE` The line property of a CAPTION event.
    `static java.lang.String` | `LINE_ANCHOR` The line anchor property of a CAPTION event.
    `static java.lang.String` | `LINE_TYPE` The line type property of a CAPTION event.
    `static java.lang.String` | `LIST` The name of the property for video list.
    `static java.lang.String` | `LIVE_WINDOW_DURATION` Deprecated.
    `static java.lang.String` | `LIVE_WINDOW_DURATION_LONG` The absolute playable window duration for a live video.
    `static java.lang.String` | `LOCALE_CODE` The key for events carrying a locale code for subtitle tracks.
    `static java.lang.String` | `MAX_POSITION` Deprecated.
    `static java.lang.String` | `MAX_POSITION_LONG` The maximum position for which a seek will be successful.
    `static java.lang.String` | `MEASURED_BPS` The key for measured bps used in the Analytics class.
    `static java.lang.String` | `MEDIA_BYTES_TRANSFERRED` The key for total number of bytes transferred by the video player.
    `static java.lang.String` | `MEDIA_CONTROLLER_CONFIG`
    `static java.lang.String` | `MIN_POSITION` Deprecated.
    `static java.lang.String` | `MIN_POSITION_LONG` The minimum position for which a seek will be successful.
    `static java.lang.String` | `NEXT_VIDEO` Video for Events that carry a next Video.
    `static java.lang.String` | `ORIGINAL_EVENT` Original event used in situations where default behavior is prevented and the original event needs to be re-emitted.
    `static java.lang.String` | `ORIGINAL_PLAYHEAD_POSITION` Deprecated.
    `static java.lang.String` | `ORIGINAL_PLAYHEAD_POSITION_LONG` The unmapped current playhead position.
    `static java.lang.String` | `ORIGINAL_SEEK_POSITION` Deprecated.
    `static java.lang.String` | `ORIGINAL_SEEK_POSITION_LONG` The unmapped seek position.
    `static java.lang.String` | `PERCENT_COMPLETE` Percentage of the video that has buffered so far.
    `static java.lang.String` | `PICTURE_IN_PICTURE_STATE` The key for events accessing Picture-in-Picture state.
    `static java.lang.String` | `PLAYBACK_LOCATION` The event property key that specifies the `PlaybackLocation`.
    `static java.lang.String` | `PLAYHEAD_POSITION` Deprecated.
    `static java.lang.String` | `PLAYHEAD_POSITION_LONG` Current playhead position in milliseconds.
    `static java.lang.String` | `PLAYLIST` Video for Events that carry a single Playlist.
    `static java.lang.String` | `PLUGIN_NAME` The name of a plugin registered to the SDK.
    `static java.lang.String` | `POSITION` The position property of a CAPTION event.
    `static java.lang.String` | `POSITION_ANCHOR` The position anchor property of a CAPTION event.
    `static java.lang.String` | `PROGRESS_BAR_PLAYHEAD_POSITION` Deprecated.
    `static java.lang.String` | `PROGRESS_BAR_PLAYHEAD_POSITION_LONG` Current playhead position in milliseconds, as shown in the Progress Bar.
    `static java.lang.String` | `PROJECTION_FORMAT` The key for the projection format sent in the Event `EventType.PROJECTION_FORMAT_CHANGED`.
    `static java.lang.String` | `RENDITION_HEIGHT` The key for rendition height used in the Analytics class.
    `static java.lang.String` | `RENDITION_INDICATED_BPS` The key for rendition indicated bps used in the Analytics class.
    `static java.lang.String` | `RENDITION_MIME_TYPE` The key for rendition mime type used in the Analytics class.
    `static java.lang.String` | `RENDITION_URL` The key for rendition urls used in the Analytics class.
    `static java.lang.String` | `RENDITION_WIDTH` The key for rendition width used in the Analytics class.
    `static java.lang.String` | `REQUEST_TOKEN` Used by the Request/Response setup; marks the id of the listener to get the response.
    `static java.lang.String` | `REQUESTED_ORIENTATION` The key for the orientation type sent in the Event `EventType.CHANGE_ORIENTATION`.
    `static java.lang.String` | `RESPONSE_TIME_MS` The key for response times in milliseconds used in the Analytics catalog response events.
    `static java.lang.String` | `RESTORE_SEEK_POSITION` Deprecated.
    `static java.lang.String` | `RESTORE_SEEK_POSITION_LONG` Position to which a seek action brings the playhead, after the player has been restored.
    `static java.lang.String` | `RIGHT_VOLUME` The setting of the right channel volume for a player (as float: 0.0f-1.0f inclusive).
    `static java.lang.String` | `SEEK_CONTROLS_VISIBILITY` The key for accessing a visibility map associating seek controls with visibility state from the event properties.
    `static java.lang.String` | `SEEK_DEFAULT` Deprecated.
    `static java.lang.String` | `SEEK_DEFAULT_LONG` The setting for the default seek time.
    `static java.lang.String` | `SEEK_ON_HOLD_UPDATE_FREQ` The setting to determine the speed we're seeking when holding down either the rewind or fast-forward button.
    `static java.lang.String` | `SEEK_ON_HOLD_WAIT_TIME` The setting to determine when the rewind or fast-forward buttons are been long-pressed and held.
    `static java.lang.String` | `SEEK_PERCENTAGE` The setting used if the seek relative is enabled.
    `static java.lang.String` | `SEEK_POSITION` Deprecated.
    `static java.lang.String` | `SEEK_POSITION_LONG` Position to which a seek action brings the playhead.
    `static java.lang.String` | `SEEK_PROGRESS` Deprecated.
    `static java.lang.String` | `SEEK_PROGRESS_LONG` The setting that has the amount of time (milliseconds) where the seek indicator must be positioned.
    `static java.lang.String` | `SEEK_RELATIVE_ENABLED` The setting to enable to seek relatively to the video duration and not by a fixed time.
    `static java.lang.String` | `SEGMENT_DURATION` The video segment's duration in milliseconds.
    `static java.lang.String` | `SELECTED_TRACK` The key for the selected track in AUDIO_TRACKS and SELECT_AUDIO_TRACK events.
    `static java.lang.String` | `SIZE` The SIZE property of a CAPTION event.
    `static java.lang.String` | `SKIP_CUE_POINTS` When added as a key to PLAY/SEEK/VIDEO_COMPLETED events, cue points will be skipped
    `static java.lang.String` | `SOURCE` Source for Events that carry a single Source.
    `static java.lang.String` | `START_TIME` Deprecated.
    `static java.lang.String` | `START_TIME_LONG` The beginning of the time range of a list of cue points
    `static java.lang.String` | `SUPPORT_FRAGMENT` The key for the Support Fragment object on FRAGMENT_ACTIVITY_CREATED event.
    `static java.lang.String` | `TEXT` The text property of a CAPTION event.
    `static java.lang.String` | `TRACKS` The key for the list of tracks in AUDIO_TRACKS events.
    `static java.lang.String` | `TTML_DOCUMENT` The key for events carrying DFXP/TTML data.
    `protected java.lang.String` | `type`
    `static java.lang.String` | `UUID` The property name of the universally unique identifier.
    `static java.lang.String` | `VALUE`
    `static java.lang.String` | `VIDEO` Video for Events that carry a single Video.
    `static java.lang.String` | `VIDEO_DURATION` Deprecated.
    `static java.lang.String` | `VIDEO_DURATION_LONG` The video's duration in milliseconds.
    `static java.lang.String` | `VIDEO_HEIGHT` Height of video.
    `static java.lang.String` | `VIDEO_STILL` URL for Events that carry a Video still image URL.
    `static java.lang.String` | `VIDEO_WIDTH` Width of video.
    `static java.lang.String` | `VOLUME` The single setting volume for a player that doesn't use channels.
    `static java.lang.String` | `WEBVTT_DOCUMENT` The key for events carrying WebVTT data.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AbstractEvent(java.lang.String type)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getId()`
    `int` | `getIntegerProperty(java.lang.String propertyName)` Convenience method for accessing a property with an integer value
    `long` | `getLongProperty(java.lang.String propertyName)` Convenience method for accessing a property with an long value
    `static int` | `getNextId()`
    `abstract java.util.Map<java.lang.String,PropertyValueType>` | `getProperties()`
    `PropertyValueType` | `getProperty(java.lang.String propertyName)`
    `<T> T` | `getProperty(java.lang.String eventPropertyId, java.lang.Class<T> type)` Returns the casted value of the eventPropertyId.
    `java.lang.String` | `getType()` The event type, typically specified from a constant value defined in EventType.
    `boolean` | `isPrevented()` Indicates that a participant of the current Event activity has prevented the default behavior for the current Event.
    `boolean` | `isStopped()` Indicates that a participant of the current Event activity has stopped the processing of any additional Events.
    `void` | `preventDefault()` Causes the Event handling framework to not execute any default behavior that may be defined for a given Event.
    `void` | `stopPropagation()` Causes the Event handling framework to stop processing any additional Events.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### CONFIGURATION

          public static final java.lang.String CONFIGURATION

      Key for Events that carry a configuration in their payload.
      See Also:
        Constant Field Values

    - #### CUE_POINT

          public static final java.lang.String CUE_POINT

      Key for Events that carry a single Cue Point.
      See Also:
        Constant Field Values

    - #### CUE_POINTS

          public static final java.lang.String CUE_POINTS

      Key for Events that carry a list of Cue Points.
      See Also:
        Constant Field Values

    - #### PLAYLIST

          public static final java.lang.String PLAYLIST

      Video for Events that carry a single Playlist.
      See Also:
        Constant Field Values

    - #### VIDEO

          public static final java.lang.String VIDEO

      Video for Events that carry a single Video.
      See Also:
        Constant Field Values

    - #### SOURCE

          public static final java.lang.String SOURCE

      Source for Events that carry a single Source.
      See Also:
        Constant Field Values

    - #### CURRENT_VIDEO

          public static final java.lang.String CURRENT_VIDEO

      Video for Events that carry a current Video.
      See Also:
        Constant Field Values

    - #### NEXT_VIDEO

          public static final java.lang.String NEXT_VIDEO

      Video for Events that carry a next Video.
      See Also:
        Constant Field Values

    - #### INDEX

          public static final java.lang.String INDEX

      Video for Events that carry a video index.
      See Also:
        Constant Field Values

    - #### VIDEO_STILL

          public static final java.lang.String VIDEO_STILL

      URL for Events that carry a Video still image URL.
      See Also:
        Constant Field Values

    - #### FROM_SEEK_POSITION

          @Deprecated
          public static final java.lang.String FROM_SEEK_POSITION

      Deprecated.
      Position from which a seek began.
      See Also:
        Constant Field Values

    - #### FROM_SEEK_POSITION_LONG

          public static final java.lang.String FROM_SEEK_POSITION_LONG

      Position from which a seek began. This is used to reference long values
      See Also:
        Constant Field Values

    - #### SEEK_POSITION

          @Deprecated
          public static final java.lang.String SEEK_POSITION

      Deprecated.
      Position to which a seek action brings the playhead.
      See Also:
        Constant Field Values

    - #### SEEK_POSITION_LONG

          public static final java.lang.String SEEK_POSITION_LONG

      Position to which a seek action brings the playhead. This is used to reference long values
      See Also:
        Constant Field Values

    - #### RESTORE_SEEK_POSITION

          @Deprecated
          public static final java.lang.String RESTORE_SEEK_POSITION

      Deprecated.
      Position to which a seek action brings the playhead, after the player has been restored.
      See Also:
        Constant Field Values

    - #### RESTORE_SEEK_POSITION_LONG

          public static final java.lang.String RESTORE_SEEK_POSITION_LONG

      Position to which a seek action brings the playhead, after the player has been restored. This is used to reference long values
      See Also:
        Constant Field Values

    - #### ORIGINAL_SEEK_POSITION

          @Deprecated
          public static final java.lang.String ORIGINAL_SEEK_POSITION

      Deprecated.
      The unmapped seek position. Used by the OnceUX plugin.
      See Also:
        Constant Field Values

    - #### ORIGINAL_SEEK_POSITION_LONG

          public static final java.lang.String ORIGINAL_SEEK_POSITION_LONG

      The unmapped seek position. Used by the OnceUX plugin. This is used to reference long values
      See Also:
        Constant Field Values

    - #### PLAYHEAD_POSITION

          @Deprecated
          public static final java.lang.String PLAYHEAD_POSITION

      Deprecated.
      Current playhead position in milliseconds.
      See Also:
        Constant Field Values

    - #### PLAYHEAD_POSITION_LONG

          public static final java.lang.String PLAYHEAD_POSITION_LONG

      Current playhead position in milliseconds. This is used to reference long values
      See Also:
        Constant Field Values

    - #### VIDEO_DURATION

          @Deprecated
          public static final java.lang.String VIDEO_DURATION

      Deprecated.
      The video's duration in milliseconds.
      See Also:
        Constant Field Values

    - #### VIDEO_DURATION_LONG

          public static final java.lang.String VIDEO_DURATION_LONG

      The video's duration in milliseconds. This is used to reference long values
      See Also:
        Constant Field Values

    - #### SEGMENT_DURATION

          public static final java.lang.String SEGMENT_DURATION

      The video segment's duration in milliseconds.
      See Also:
        Constant Field Values

    - #### MAX_POSITION

          @Deprecated
          public static final java.lang.String MAX_POSITION

      Deprecated.
      The maximum position for which a seek will be successful.
      See Also:
        Constant Field Values

    - #### MAX_POSITION_LONG

          public static final java.lang.String MAX_POSITION_LONG

      The maximum position for which a seek will be successful.
      See Also:
        Constant Field Values

    - #### MIN_POSITION

          @Deprecated
          public static final java.lang.String MIN_POSITION

      Deprecated.
      The minimum position for which a seek will be successful.
      See Also:
        Constant Field Values

    - #### MIN_POSITION_LONG

          public static final java.lang.String MIN_POSITION_LONG

      The minimum position for which a seek will be successful.
      See Also:
        Constant Field Values

    - #### LIVE_WINDOW_DURATION

          @Deprecated
          public static final java.lang.String LIVE_WINDOW_DURATION

      Deprecated.
      The absolute playable window duration for a live video.
      See Also:
        Constant Field Values

    - #### LIVE_WINDOW_DURATION_LONG

          public static final java.lang.String LIVE_WINDOW_DURATION_LONG

      The absolute playable window duration for a live video.
      See Also:
        Constant Field Values

    - #### PERCENT_COMPLETE

          public static final java.lang.String PERCENT_COMPLETE

      Percentage of the video that has buffered so far.
      See Also:
        Constant Field Values

    - #### ERROR_MESSAGE

          public static final java.lang.String ERROR_MESSAGE

      Used to transmit an error message when an error occurs
      See Also:
        Constant Field Values

    - #### ERROR_CODE

          public static final java.lang.String ERROR_CODE

      Key for the error code sent for a non-playable source
      See Also:
        Constant Field Values

    - #### ERROR_SUBCODE

          public static final java.lang.String ERROR_SUBCODE

      Key for the error subcode sent for a non-playable source
      See Also:
        Constant Field Values

    - #### ERROR_EXTRA

          public static final java.lang.String ERROR_EXTRA

      Key for the extra code sent during an error for non-playable source
      See Also:
        Constant Field Values

    - #### ERROR

          public static final java.lang.String ERROR

      Key for an actual exception associated with a playback error
      See Also:
        Constant Field Values

    - #### ERRORS

          public static final java.lang.String ERRORS

      Key for list of error messages in a response.
      See Also:
        Constant Field Values

    - #### VIDEO_WIDTH

          public static final java.lang.String VIDEO_WIDTH

      Width of video. Used for VIDEO_SIZE_KNOWN.
      See Also:
        Constant Field Values

    - #### VIDEO_HEIGHT

          public static final java.lang.String VIDEO_HEIGHT

      Height of video. Used for VIDEO_SIZE_KNOWN.
      See Also:
        Constant Field Values

    - #### REQUEST_TOKEN

          public static final java.lang.String REQUEST_TOKEN

      Used by the Request/Response setup; marks the id of the listener to get the response.
      See Also:
        Constant Field Values

    - #### DEBUG

          public static final java.lang.String DEBUG

      Whether components should emit additional debug information.
      See Also:
        Constant Field Values

    - #### EMITTER

          public static final java.lang.String EMITTER

      The simple name of the source component for an event when running in debug mode
      See Also:
        Constant Field Values

    - #### ORIGINAL_EVENT

          public static final java.lang.String ORIGINAL_EVENT

      Original event used in situations where default behavior is prevented and the original event needs to be re-emitted.
      See Also:
        Constant Field Values

    - #### EVENT_SOURCE

          public static final java.lang.String EVENT_SOURCE

      Property that specifies the source class where the event originated.
      See Also:
        Constant Field Values

    - #### LIST

          public static final java.lang.String LIST

      The name of the property for video list.
      See Also:
        Constant Field Values

    - #### UUID

          public static final java.lang.String UUID

      The property name of the universally unique identifier.
      See Also:
        Constant Field Values

    - #### ID

          public static final java.lang.String ID

      The property name of the unique identifier.
      See Also:
        Constant Field Values

    - #### START_TIME

          @Deprecated
          public static final java.lang.String START_TIME

      Deprecated.
      The beginning of the time range of a list of cue points
      See Also:
        Constant Field Values

    - #### START_TIME_LONG

          public static final java.lang.String START_TIME_LONG

      The beginning of the time range of a list of cue points
      See Also:
        Constant Field Values

    - #### END_TIME

          @Deprecated
          public static final java.lang.String END_TIME

      Deprecated.
      The end of the time range of a list of cue points
      See Also:
        Constant Field Values

    - #### END_TIME_LONG

          public static final java.lang.String END_TIME_LONG

      The end of the time range of a list of cue points
      See Also:
        Constant Field Values

    - #### SKIP_CUE_POINTS

          public static final java.lang.String SKIP_CUE_POINTS

      When added as a key to PLAY/SEEK/VIDEO_COMPLETED events, cue points will be skipped
      See Also:
        Constant Field Values

    - #### PLUGIN_NAME

          public static final java.lang.String PLUGIN_NAME

      The name of a plugin registered to the SDK.
      See Also:
        Constant Field Values

    - #### LEFT_VOLUME

          public static final java.lang.String LEFT_VOLUME

      The setting of the left channel volume for a player (as float: 0.0f-1.0f inclusive).
      See Also:
        Constant Field Values

    - #### RIGHT_VOLUME

          public static final java.lang.String RIGHT_VOLUME

      The setting of the right channel volume for a player (as float: 0.0f-1.0f inclusive).
      See Also:
        Constant Field Values

    - #### VOLUME

          public static final java.lang.String VOLUME

      The single setting volume for a player that doesn't use channels. (as float: 0.0f-1.0f inclusive).
      See Also:
        Constant Field Values

    - #### SEEK_CONTROLS_VISIBILITY

          public static final java.lang.String SEEK_CONTROLS_VISIBILITY

      The key for accessing a visibility map associating seek controls with visibility state from the event properties.
      See Also:
        Constant Field Values

    - #### SEEK_PROGRESS

          @Deprecated
          public static final java.lang.String SEEK_PROGRESS

      Deprecated.
      The setting that has the amount of time (milliseconds) where the seek indicator must be positioned.
      See Also:
        Constant Field Values

    - #### SEEK_PROGRESS_LONG

          public static final java.lang.String SEEK_PROGRESS_LONG

      The setting that has the amount of time (milliseconds) where the seek indicator must be positioned.
      See Also:
        Constant Field Values

    - #### SEEK_DEFAULT

          @Deprecated
          public static final java.lang.String SEEK_DEFAULT

      Deprecated.
      The setting for the default seek time.
      See Also:
        Constant Field Values

    - #### SEEK_DEFAULT_LONG

          public static final java.lang.String SEEK_DEFAULT_LONG

      The setting for the default seek time.
      See Also:
        Constant Field Values

    - #### SEEK_RELATIVE_ENABLED

          public static final java.lang.String SEEK_RELATIVE_ENABLED

      The setting to enable to seek relatively to the video duration and not by a fixed time.
      See Also:
        Constant Field Values

    - #### SEEK_PERCENTAGE

          public static final java.lang.String SEEK_PERCENTAGE

      The setting used if the seek relative is enabled. Is used to calculate the see time for each video duration.
      See Also:
        Constant Field Values

    - #### SEEK_ON_HOLD_WAIT_TIME

          public static final java.lang.String SEEK_ON_HOLD_WAIT_TIME

      The setting to determine when the rewind or fast-forward buttons are been long-pressed and held.
      See Also:
        Constant Field Values

    - #### SEEK_ON_HOLD_UPDATE_FREQ

          public static final java.lang.String SEEK_ON_HOLD_UPDATE_FREQ

      The setting to determine the speed we're seeking when holding down either the rewind or fast-forward button.
      See Also:
        Constant Field Values

    - #### BUILD_VERSION

          public static final java.lang.String BUILD_VERSION

      See Also:
        Constant Field Values

    - #### INSTANCE_STATE

          public static final java.lang.String INSTANCE_STATE

      The key for saving and restoring instance state on a lifecycle event. Provides access to the Bundle object in which state is saved or from which state is restored.
      See Also:
        Constant Field Values

    - #### ACTIVITY

          public static final java.lang.String ACTIVITY

      The key for Activity on the FRAGMENT_ATTACHED lifecycle event.
      See Also:
        Constant Field Values

    - #### FRAGMENT

          public static final java.lang.String FRAGMENT

      The key for the Fragment object on FRAGMENT_ACTIVITY_CREATED event.
      See Also:
        Constant Field Values

    - #### SUPPORT_FRAGMENT

          public static final java.lang.String SUPPORT_FRAGMENT

      The key for the Support Fragment object on FRAGMENT_ACTIVITY_CREATED event.
      See Also:
        Constant Field Values

    - #### BOOLEAN

          public static final java.lang.String BOOLEAN

      The key for a general boolean property.
      See Also:
        Constant Field Values

    - #### TTML_DOCUMENT

          public static final java.lang.String TTML_DOCUMENT

      The key for events carrying DFXP/TTML data.
      See Also:
        Constant Field Values

    - #### WEBVTT_DOCUMENT

          public static final java.lang.String WEBVTT_DOCUMENT

      The key for events carrying WebVTT data.
      See Also:
        Constant Field Values

    - #### VALUE

          public static final java.lang.String VALUE

      See Also:
        Constant Field Values

    - #### CEA608_DOCUMENT

          public static final java.lang.String CEA608_DOCUMENT

      The key for events carrying CEA-608 data.
      See Also:
        Constant Field Values

    - #### CEA708_DOCUMENT

          public static final java.lang.String CEA708_DOCUMENT

      The key for events carrying CEA-708 data.
      See Also:
        Constant Field Values

    - #### LOCALE_CODE

          public static final java.lang.String LOCALE_CODE

      The key for events carrying a locale code for subtitle tracks.
      See Also:
        Constant Field Values

    - #### CAPTION_FORMAT

          public static final java.lang.String CAPTION_FORMAT

      The key containing the `BrightcoveCaptionFormat` selected.
      See Also:
        Constant Field Values

    - #### CAPTION_URI

          public static final java.lang.String CAPTION_URI

      The key containing the uri for the `BrightcoveCaptionFormat` selected.
      See Also:
        Constant Field Values

    - #### ALIGNMENT

          public static final java.lang.String ALIGNMENT

      The alignment property of a CAPTION event.
      See Also:
        Constant Field Values

    - #### LINE

          public static final java.lang.String LINE

      The line property of a CAPTION event.
      See Also:
        Constant Field Values

    - #### LINE_TYPE

          public static final java.lang.String LINE_TYPE

      The line type property of a CAPTION event.
      See Also:
        Constant Field Values

    - #### LINE_ANCHOR

          public static final java.lang.String LINE_ANCHOR

      The line anchor property of a CAPTION event.
      See Also:
        Constant Field Values

    - #### SIZE

          public static final java.lang.String SIZE

      The SIZE property of a CAPTION event.
      See Also:
        Constant Field Values

    - #### POSITION

          public static final java.lang.String POSITION

      The position property of a CAPTION event.
      See Also:
        Constant Field Values

    - #### POSITION_ANCHOR

          public static final java.lang.String POSITION_ANCHOR

      The position anchor property of a CAPTION event.
      See Also:
        Constant Field Values

    - #### TEXT

          public static final java.lang.String TEXT

      The text property of a CAPTION event.
      See Also:
        Constant Field Values

    - #### CAPTIONS_STATE

          public static final java.lang.String CAPTIONS_STATE

      The key for events accessing caption state. Saved and restored for configuration change or Activity restart.
      See Also:
        Constant Field Values

    - #### LANGUAGES

          public static final java.lang.String LANGUAGES

      The key for the list of languages in CAPTIONS_LANGUAGES events.
      See Also:
        Constant Field Values

    - #### AUDIO_TRACKS_STATE

          public static final java.lang.String AUDIO_TRACKS_STATE

      The key for events accessing audio tracks state. Saved and restored for configuration change or Activity restart..
      See Also:
        Constant Field Values

    - #### PICTURE_IN_PICTURE_STATE

          public static final java.lang.String PICTURE_IN_PICTURE_STATE

      The key for events accessing Picture-in-Picture state. Saved and restored for configuration change or Activity restart.
      See Also:
        Constant Field Values

    - #### TRACKS

          public static final java.lang.String TRACKS

      The key for the list of tracks in AUDIO_TRACKS events.
      See Also:
        Constant Field Values

    - #### SELECTED_TRACK

          public static final java.lang.String SELECTED_TRACK

      The key for the selected track in AUDIO_TRACKS and SELECT_AUDIO_TRACK events.
      See Also:
        Constant Field Values

    - #### AUDIO_VARIANT

          public static final java.lang.String AUDIO_VARIANT

      The key for the list of audio variants in AUDIO_TRACKS events.
      See Also:
        Constant Field Values

    - #### ORIGINAL_PLAYHEAD_POSITION

          @Deprecated
          public static final java.lang.String ORIGINAL_PLAYHEAD_POSITION

      Deprecated.
      The unmapped current playhead position. Used by the OnceUX plugin and the BrightcoveClosedCaptioningView.
      See Also:
        Constant Field Values

    - #### ORIGINAL_PLAYHEAD_POSITION_LONG

          public static final java.lang.String ORIGINAL_PLAYHEAD_POSITION_LONG

      The unmapped current playhead position. Used by the OnceUX plugin and the BrightcoveClosedCaptioningView. This is used to reference long values
      See Also:
        Constant Field Values

    - #### PROGRESS_BAR_PLAYHEAD_POSITION

          @Deprecated
          public static final java.lang.String PROGRESS_BAR_PLAYHEAD_POSITION

      Deprecated.
      Current playhead position in milliseconds, as shown in the Progress Bar.
      See Also:
        Constant Field Values

    - #### PROGRESS_BAR_PLAYHEAD_POSITION_LONG

          public static final java.lang.String PROGRESS_BAR_PLAYHEAD_POSITION_LONG

      Current playhead position in milliseconds, as shown in the Progress Bar. This is used to reference long values
      See Also:
        Constant Field Values

    - #### CATALOG_URL

          public static final java.lang.String CATALOG_URL

      The key for catalog urls used in the Analytics catalog request and response events.
      See Also:
        Constant Field Values

    - #### RENDITION_URL

          public static final java.lang.String RENDITION_URL

      The key for rendition urls used in the Analytics class.
      See Also:
        Constant Field Values

    - #### RENDITION_INDICATED_BPS

          public static final java.lang.String RENDITION_INDICATED_BPS

      The key for rendition indicated bps used in the Analytics class.
      See Also:
        Constant Field Values

    - #### RENDITION_MIME_TYPE

          public static final java.lang.String RENDITION_MIME_TYPE

      The key for rendition mime type used in the Analytics class.
      See Also:
        Constant Field Values

    - #### RENDITION_HEIGHT

          public static final java.lang.String RENDITION_HEIGHT

      The key for rendition height used in the Analytics class.
      See Also:
        Constant Field Values

    - #### RENDITION_WIDTH

          public static final java.lang.String RENDITION_WIDTH

      The key for rendition width used in the Analytics class.
      See Also:
        Constant Field Values

    - #### FORWARD_BUFFER_SECONDS

          public static final java.lang.String FORWARD_BUFFER_SECONDS

      The key for forward buffer seconds used in the Analytics class.
      See Also:
        Constant Field Values

    - #### MEASURED_BPS

          public static final java.lang.String MEASURED_BPS

      The key for measured bps used in the Analytics class.
      See Also:
        Constant Field Values

    - #### MEDIA_BYTES_TRANSFERRED

          public static final java.lang.String MEDIA_BYTES_TRANSFERRED

      The key for total number of bytes transferred by the video player.
      See Also:
        Constant Field Values

    - #### RESPONSE_TIME_MS

          public static final java.lang.String RESPONSE_TIME_MS

      The key for response times in milliseconds used in the Analytics catalog response events.
      See Also:
        Constant Field Values

    - #### AD_ID

          public static final java.lang.String AD_ID

      The key for ad id used in advertising events.
      See Also:
        Constant Field Values

    - #### AD_TITLE

          public static final java.lang.String AD_TITLE

      The key for ad title used in advertising events.
      See Also:
        Constant Field Values

    - #### PROJECTION_FORMAT

          public static final java.lang.String PROJECTION_FORMAT

      The key for the projection format sent in the Event `EventType.PROJECTION_FORMAT_CHANGED`.
      See Also:
        Constant Field Values

    - #### REQUESTED_ORIENTATION

          public static final java.lang.String REQUESTED_ORIENTATION

      The key for the orientation type sent in the Event `EventType.CHANGE_ORIENTATION`.
      See Also:
        Constant Field Values

    - #### PLAYBACK_LOCATION

          public static final java.lang.String PLAYBACK_LOCATION

      The event property key that specifies the `PlaybackLocation`. Currently used when using the Cast plugin.
      See Also:
        Constant Field Values

    - #### MEDIA_CONTROLLER_CONFIG

          public static final java.lang.String MEDIA_CONTROLLER_CONFIG

      See Also:
        Constant Field Values

    - #### BRIGHTCOVE_CONTROL_BAR

          public static final java.lang.String BRIGHTCOVE_CONTROL_BAR

      The event property that specifies the `BrightcoveControlBar`.
      See Also:
        Constant Field Values

    - #### BRIGHTCOVE_MEDIA_CONTROLLER

          public static final java.lang.String BRIGHTCOVE_MEDIA_CONTROLLER

      The event property that specifies the `BrightcoveMediaController`.
      See Also:
        Constant Field Values

    - #### ANDROID_VIEW

          public static final java.lang.String ANDROID_VIEW

      The event property that specifies `View`.
      See Also:
        Constant Field Values

    - #### GSC_MAX_CONCURRENCY_REACHED_MESSAGE

          public static final java.lang.String GSC_MAX_CONCURRENCY_REACHED_MESSAGE

      Key for the max concurrency reached message
      See Also:
        Constant Field Values

    - #### type

          protected final java.lang.String type

    - #### isStopped

          protected boolean isStopped

    - #### isPrevented

          protected boolean isPrevented

  - ### Constructor Detail

    - #### AbstractEvent

          public AbstractEvent(@NonNull
                               java.lang.String type)

  - ### Method Detail

    - #### getNextId

          public static int getNextId()

      Returns:
        The next unique id.

    - #### getId

          public int getId()

      Returns:
        The unique id.

    - #### getType

          public java.lang.String getType()

      The event type, typically specified from a constant value defined in EventType.
      Returns:
        the String indicating the type of Event

    - #### preventDefault

          public void preventDefault()

      Causes the Event handling framework to not execute any default behavior that may be defined for a given Event.

    - #### stopPropagation

          public void stopPropagation()

      Causes the Event handling framework to stop processing any additional Events.

    - #### isPrevented

          public boolean isPrevented()

      Indicates that a participant of the current Event activity has prevented the default behavior for the current Event.
      Returns:
        true if the default behavior has been prevented

    - #### isStopped

          public boolean isStopped()

      Indicates that a participant of the current Event activity has stopped the processing of any additional Events.
      Returns:
        true if Event processing was stopped

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`

    - #### getProperty

          @Nullable
          public PropertyValueType getProperty(@NonNull
                                                         java.lang.String propertyName)

    - #### getProperty

          public <T> T getProperty(java.lang.String eventPropertyId,
                                   java.lang.Class<T> type)

      Returns the casted value of the eventPropertyId.
      Type Parameters:
        `T` - the expected type.
      Parameters:
        `eventPropertyId` - the id of the property to retrieve.
        `type` - the class to be casted.
      Returns:
        the casted value of the eventPropertyId.

    - #### getIntegerProperty

          public int getIntegerProperty(@NonNull
                                        java.lang.String propertyName)

      Convenience method for accessing a property with an integer value
      Parameters:
        `propertyName` - Name of property to access
      Returns:
        value of the integer, will be -1 if not found or error

    - #### getLongProperty

          public long getLongProperty(@NonNull
                                      java.lang.String propertyName)

      Convenience method for accessing a property with an long value
      Parameters:
        `propertyName` - Name of property to access
      Returns:
        value of the long, will be -1 if not found or error

    - #### getProperties

          @NonNull
          public abstract java.util.Map<java.lang.String,PropertyValueType> getProperties()